; ===============================================================
; Slippy
; ===============================================================

.module Program
.export

GBUF		= plotSScreen

MAPX 	   	= SAFERAM2
MAPY 	   	= SAFERAM3+1
POS		= SAFERAM3+2
TEMPX	   	= SAFERAM3+3
TEMPY	  	= SAFERAM3+4
TEMPPOS  	= SAFERAM3+5
SLIPY    	= SAFERAM3+6
SLIPX 	  	= SAFERAM3+7
SLIPPOS  	= SAFERAM3+8
LADRESS  	= SAFERAM3+9  ;16-BIT ADRESS OF THE NEXT MAP (SAFERAM9-10)
LCURRENT 	= SAFERAM3+11 ;16-BIT ADRESS OF THE CURRENT MAP (SAFERAM10-11)
LAMOUNT  	= SAFERAM3+13 ;THE AMOUNT OF LEVELS
COINS    	= SAFERAM3+14 ;THE AMOUNT OF COINS WHICH HAVE TO BE COLLECTED
SELLEVEL 	= SAFERAM3+15 ;THE LEVEL SELECTED IN THE SELECTION SCREEN

DKDown		.equ 254 
DKLeft		.equ 253 
DKRight	.equ 251 
DKUp		.equ 247 
DKClear	.equ 191
DK2nd		.equ 223
DKMode		.equ 191


; ===============================================================
; Main entry point
; ===============================================================

main
;==========================================================
; start of program
;==========================================================
	;CALL GSCLEARBUFFER	
	;CALL GSSETFREQ
	CALL GSENABLE
LEVELSELECTION:
	CALL GSCLEARBUFFER
	ld   b,10
	ld   c,6
	ld   a,48
	ld   l,2
	ld   ix,Title
	CALL GSLARGESPRITE
	ld   b,59
	ld   c,6
	ld   a,0
	ld   l,4
	ld   ix,Slippy
	CALL GSLARGESPRITE		
	CALL INITVALUES
	LD   A,1
	LD   (SELLEVEL),A
	LD   HL,1342H
  	LD   (PENCOL),HL
	LD   HL,LEVEL_TEXT
	bcall(_VPUTS)
	LD   HL,2830H
	LD   (PENCOL),HL
	LD   HL,CHANGE_TEXT
	bcall(_VPUTS)
	LD   HL,303EH
	LD   (PENCOL),HL
	LD   HL,START_TEXT
	bcall(_VPUTS)
	LD   HL,383FH	
	LD   (PENCOL),HL
	LD   HL,QUIT_TEXT	
	bcall(_VPUTS)
LEVELSELECTIONLOOP:
	LD   A,(SELLEVEL)
	LD   H,$00
	LD   L,A
	LD   DE,TEMP_TEXT
	CALL LBLNUM2DEC
  	LD   HL,1357H
  	LD   (PENCOL),HL
	LD   HL,TEMP_TEXT+3
	bcall(_VPUTS)
	CALL GSCOPYBUFFER
	CALL GSGETK
	CP   sKRIGHT
	JR   Z,SELECTRIGHT
	CP   sKLEFT
	JR   Z,SELECTLEFT
	CP   sKMODE
	JP   Z,QUIT
	CP   sK2ND
	JR   Z,SELECTIONFINISHED
	JR   LEVELSELECTIONLOOP
SELECTLEFT:
	LD   B,15
	CALL DELAY
	LD   A,(SELLEVEL)
	DEC  A
	JR   Z,LEVELSELECTIONLOOP
	LD   (SELLEVEL),A
	JR   LEVELSELECTIONLOOP
SELECTRIGHT:
	LD   B,15
	CALL DELAY
	LD   A,(LEVELMAX)
	LD   B,A
	LD   A,(SELLEVEL)
	CP   B
	JR   Z,LEVELSELECTIONLOOP
	INC  A
	LD   (SELLEVEL),A
	JR   LEVELSELECTIONLOOP
SELECTIONFINISHED:
	CALL LOADSELECTEDADRESS
	CALL LOADLEVEL
	CALL COUNTCOINS
	CALL GSCLEARBUFFER
	LD   HL,LEVEL
	CALL DRAWMAP
	CALL GSCOPYBUFFER

MAINLOOP:
	LD   B,10
	CALL DELAY
	LD   A,$FF
  	OUT  (1),A
	LD   A,$BF
	OUT  (1),A
	IN   A,(1)
	CP   DKMODE
	JP   Z,LEVELSELECTION
	LD   A,$FF
	OUT  (1),A						
	LD   A,$FE
	OUT  (1),A 				
	IN   A,(1)
	CP   DKDOWN 			
	JP   Z,GODOWN
	CP   DKUP
	JP   Z,GOUP
	CP   DKRIGHT
	JP   Z,GORIGHT
	CP   DKLEFT
	JP   Z,GOLEFT
	LD   A,$FF
	OUT  (1),A
	LD   A,$FD
	OUT  (1),A 
	IN   A,(1)
	CP   DKCLEAR
	JP   Z,RESETLEVEL
	JR   MAINLOOP
QUIT:
	CALL GSDISABLE
	RET
;==========================================================
; Checks whether Slippy can be teleported to the other side
;==========================================================
GOCHECKTELDOWN:
	LD   A,(SLIPPOS)
	SUB  144
	CALL CHECKPOS
	OR   A
	JR   Z,TELDOWN
	JP   GOQUIT
TELDOWN:
	LD   A,(SLIPPOS)
	SUB  144
	CALL GOXY
	XOR  A
	LD   (SLIPY),A
	JP   MOVEMENTEND
	
GOCHECKTELUP:
	LD   A,(SLIPPOS)
	ADD  A,144
	CALL CHECKPOS
	OR   A
	JR   Z,TELUP
	JP   GOQUIT
TELUP:
	LD   A,(SLIPPOS)
	ADD  A,144
	CALL GOXY
  	LD   A,54
	LD   (SLIPY),A
	JP   MOVEMENTEND

GOCHECKTELLEFT:
	LD   A,(SLIPPOS)
	ADD  A,15
	CALL CHECKPOS
	OR   A
	JR   Z,TELLEFT
	JP   GOQUIT
TELLEFT:
	LD   A,(SLIPPOS)
	ADD  A,15
	CALL GOXY
	LD   A,90
	LD   (SLIPX),A
	JR   MOVEMENTEND
	
GOCHECKTELRIGHT:
	LD   A,(SLIPPOS)
	SUB  15
	CALL CHECKPOS
	OR   A
	JR   Z,TELRIGHT
	JP   GOQUIT
TELRIGHT:
	LD   A,(SLIPPOS)
	SUB  15
	CALL GOXY
	XOR  A
	LD   (SLIPX),A
	JR   MOVEMENTEND
	
;==========================================================
; Movement Routines from Slippy
;==========================================================
GODOWN:
	LD   A,(SLIPY)
	CP   54
	JP   Z,GOCHECKTELDOWN
	ADD  A,6
	CALL GOY
	ADD  A,16
	LD  (TEMPPOS),A
	CALL CHECKPOS
	CP   3
	JP   Z,ICECUBEDOWN
	CALL COMPARE
	ADD  A,16
	CALL GOXY
	LD   A,(SLIPY)	
	ADD  A,6
	LD   (SLIPY),A	
	JR   MOVEMENTEND

GOUP:
	LD   A,(SLIPY)
	OR   A
	JP   Z,GOCHECKTELUP
	SUB  6	
	CALL GOY
	SUB  16
	LD   (TEMPPOS),A
	CALL CHECKPOS
	CP   3
	JP   Z,ICECUBEUP
	CALL COMPARE
	SUB  16
	CALL GOXY
	LD   A,(SLIPY)
	SUB  6
	LD   (SLIPY),A	
	JR   MOVEMENTEND

MOVEMENTEND:	
	CALL PUTSLIP
	CALL GSCOPYBUFFER
GOQUIT:
	LD   A,(COINS)
	OR   A
	JP   Z,NEXTLEVEL
	LD   B,15
	CALL DELAY
	JP   MAINLOOP
	
GORIGHT:
	LD   A,(SLIPX)
	CP   90
	JP   Z,GOCHECKTELRIGHT
	ADD  A,6
	CALL GOX
	INC  A
	LD   (TEMPPOS),A
	CALL CHECKPOS
	CP   3
	JP   Z,ICECUBERIGHT	
	CALL COMPARE
	INC  A
	CALL GOXY
	LD   A,(SLIPX)
	ADD  A,6
	LD   (SLIPX),A
	JR   MOVEMENTEND
	
GOLEFT:
	LD   A,(SLIPX)
	OR   A
	JP   Z,GOCHECKTELLEFT
	SUB  6
	CALL GOX
	DEC  A
	LD   (TEMPPOS),A
	CALL CHECKPOS
	CP   3
	JP   Z,ICECUBELEFT
	CALL COMPARE
	DEC  A
	CALL GOXY
	LD   A,(SLIPX)
	SUB  6
	LD   (SLIPX),A	
	JR   MOVEMENTEND
;==========================================================
; Return the value of pos A in the map
;==========================================================
CHECKPOS:
	LD   D,$00
	LD   E,A
	LD   HL,LEVEL
	ADD  HL,DE
	LD   A,(HL)
	RET	

;==========================================================
; Movement Routines from the IceCube
;==========================================================
ICECUBELEFT:
	LD   A,(TEMPX)
	OR   A
	JP   Z,ENCOUNTEREND
	LD   A,(TEMPPOS)
	DEC  A
	CALL CHECKPOS
	CP   4
	JP   Z,ENCOUNTERHOLELEFT
	OR   A
	JP   NZ,GOQUIT
	CALL NEWPOS	
	LD   HL,TEMPPOS
	DEC  (HL)
	CALL NEWPOS	
	LD 	 B,3	
ICECUBELEFTANILOOP:
	PUSH BC
	CALL PUTICECUBE
	LD   HL,TEMPX
	DEC  (HL)
	DEC  (HL)
	CALL PUTICECUBE
	CALL GSCOPYBUFFER
	POP  BC
	DJNZ ICECUBELEFTANILOOP	
	JR   ICECUBELEFT

ICECUBERIGHT:
	LD   A,(TEMPX)
	CP   90
	JP   Z,ENCOUNTEREND
	LD   A,(TEMPPOS)
	INC  A
	CALL CHECKPOS
	CP   4
	JP   Z,ENCOUNTERHOLERIGHT
	OR   A
	JP   NZ,GOQUIT
	CALL NEWPOS	
	LD   HL,TEMPPOS
	INC  (HL)
	CALL NEWPOS	
	LD 	 B,3	
ICECUBERIGHTANILOOP:
	PUSH BC
	CALL PUTICECUBE
	LD   HL,TEMPX
	INC  (HL)
	INC  (HL)
	CALL PUTICECUBE
	CALL GSCOPYBUFFER
	POP  BC
	DJNZ ICECUBERIGHTANILOOP	
	JR   ICECUBERIGHT

ICECUBEUP:
	LD   A,(TEMPY)
	OR   A
	JP   Z,ENCOUNTEREND
	LD   A,(TEMPPOS)
	SUB  16
	CALL CHECKPOS
	CP   4
	JP   Z,ENCOUNTERHOLEUP
	OR   A
	JP   NZ,GOQUIT
	CALL NEWPOS
	LD   A,(TEMPPOS)
	SUB  16
	LD   (TEMPPOS),A	
	CALL NEWPOS	
	LD 	 B,3	
ICECUBEUPANILOOP:
	PUSH BC
	CALL PUTICECUBE
	LD   HL,TEMPY
	DEC  (HL)
	DEC  (HL)
	CALL PUTICECUBE
	CALL GSCOPYBUFFER
	POP  BC
	DJNZ ICECUBEUPANILOOP	
	JR   ICECUBEUP

ICECUBEDOWN:
	LD   A,(TEMPY)
	OR   A
	JP   Z,ENCOUNTEREND
	LD   A,(TEMPPOS)
	ADD  A,16
	CALL CHECKPOS
	CP   4
	JP   Z,ENCOUNTERHOLEDOWN
	OR   A
	JP   NZ,GOQUIT
	CALL NEWPOS	
	LD   A,(TEMPPOS)
	ADD  A,16
	LD  (TEMPPOS),A	
	CALL NEWPOS	
	LD 	 B,3	
ICECUBEDOWNANILOOP:
	PUSH BC
	CALL PUTICECUBE
	LD   HL,TEMPY
	INC  (HL)
	INC  (HL)
	CALL PUTICECUBE
	CALL GSCOPYBUFFER
	POP  BC	
	DJNZ ICECUBEDOWNANILOOP	
	JR   ICECUBEDOWN
	
;==========================================================
; Encounterhole routines
;==========================================================
ENCOUNTEREND:
	CALL PUTICECUBE
	CALL NEWPOS
	CALL GSCOPYBUFFER
	JP   GOQUIT
	
ENCOUNTERHOLELEFT:
	LD   B,3
ENCOUNTERLEFTANILOOP:
	PUSH BC
	CALL PUTICECUBE
	LD   HL,TEMPX
	DEC  (HL)
	DEC  (HL)
	CALL PUTICECUBE
	CALL GSCOPYBUFFER
	LD   B,10
	CALL DELAY
	POP  BC	
	DJNZ ENCOUNTERLEFTANILOOP
	CALL PUTICECUBE
	CALL NEWPOS
	CALL PUTHOLE
	LD   HL,TEMPPOS
	DEC  (HL)
	CALL NEWPOS2
	CALL GSCOPYBUFFER
	JP   GOQUIT

ENCOUNTERHOLERIGHT:
	LD   B,3
ENCOUNTERRIGHTANILOOP:
	PUSH BC
	CALL PUTICECUBE
	LD   HL,TEMPX
	INC  (HL)
	INC  (HL)
	CALL PUTICECUBE
	CALL GSCOPYBUFFER
	LD   B,10
	CALL DELAY
	POP  BC	
	DJNZ ENCOUNTERRIGHTANILOOP
	CALL PUTICECUBE
	CALL NEWPOS
	CALL PUTHOLE
	LD   HL,TEMPPOS
	INC  (HL)
	CALL NEWPOS2
	CALL GSCOPYBUFFER
	JP   GOQUIT

ENCOUNTERHOLEUP:
	LD   B,3
ENCOUNTERUPANILOOP:
	PUSH BC
	CALL PUTICECUBE
	LD   HL,TEMPY
	DEC  (HL)
	DEC  (HL)
	CALL PUTICECUBE
	CALL GSCOPYBUFFER
	LD   B,10
	CALL DELAY
	POP  BC	
	DJNZ ENCOUNTERUPANILOOP
	CALL PUTICECUBE
	CALL NEWPOS
	CALL PUTHOLE
	LD   A,(TEMPPOS)	
	SUB  16
	LD   (TEMPPOS),A
	CALL NEWPOS2
	CALL GSCOPYBUFFER
	JP   GOQUIT

ENCOUNTERHOLEDOWN:
	LD   B,3
ENCOUNTERDOWNANILOOP:
	PUSH BC
	CALL PUTICECUBE
	LD   HL,TEMPY
	INC  (HL)
	INC  (HL)
	CALL PUTICECUBE
	CALL GSCOPYBUFFER
	LD   B,10
	CALL DELAY
	POP  BC	
	DJNZ ENCOUNTERDOWNANILOOP
	CALL PUTICECUBE
	CALL NEWPOS
	CALL PUTHOLE
	LD   A,(TEMPPOS)	
	ADD  A,16
	LD   (TEMPPOS),A
	CALL NEWPOS2
	CALL GSCOPYBUFFER
	JP   GOQUIT

;==========================================================
; PutIceCube - Plots the Icecube on the screen
;==========================================================
PUTHOLE:
	LD   IX,HOLE
	LD   A,(TEMPY)
	LD   L,A
	LD   A,(TEMPX)
	LD   B,6
	CALL GSPUTSPRITE
	RET
;==========================================================
; EncounterCoin - The routine for when slippy encounters a coin
;==========================================================
ENCOUNTERCOIN:
	LD   A,(TEMPPOS)
	LD   E,A
	LD   D,$00
	LD   HL,LEVEL
	ADD  HL,DE
	LD   A,(HL)
	XOR  2
	LD   (HL),A
	LD   IX,COIN
	LD   A,(TEMPY)
	LD   L,A
	LD   A,(TEMPX)
	LD   B,6
	CALL GSPUTSPRITE
	LD   HL,COINS
	DEC  (HL)
	XOR  A
	RET

;==========================================================
; PutIceCube - Plots the Icecube on the screen
;==========================================================
PUTICECUBE:
	LD   IX,ICECUBE
	LD   A,(TEMPY)
	LD   L,A
	LD   A,(TEMPX)
	LD   B,6
	CALL GSPUTSPRITE
	RET
;==========================================================
; Common Movement - This are the Call's made in the movement 
; 					routines to safe some bytes ;-)
;==========================================================
GOY:
	LD   (TEMPY),A
	LD   A,(SLIPX)
	LD   (TEMPX),A
	LD   A,(SLIPPOS)
	RET
GOX:
	LD   (TEMPX),A
	LD   A,(SLIPY)
	LD   (TEMPY),A
	LD   A,(SLIPPOS)
	RET  
GOXY:  
	LD   (SLIPPOS),A
	CALL PUTSLIP
	RET	 
COMPARE:
	CP   2
	CALL Z,ENCOUNTERCOIN
	OR   A
	JR   NZ,GOQUITCOMPARE
	LD   A,(SLIPPOS)
	RET  
GOQUITCOMPARE:
	POP  HL
	JP   GOQUIT

;==========================================================
; newpos - XOR's the pos to the map
;==========================================================
NEWPOS:
	LD   B,3
	CALL XORPOS
	RET

NEWPOS2:
	LD   B,4
	CALL XORPOS
	RET

XORPOS:
	LD   A,(TEMPPOS)
	LD   E,A
	LD   D,$00
	LD   HL,LEVEL
	ADD  HL,DE
	LD   A,(HL)
	XOR  B
	LD   (HL),A
	RET
	
;==========================================================
; PutSlip - Plots Slippy on the screen
;==========================================================
PUTSLIP:
	LD   IX,PLAYERTILE
	LD   A,(SLIPY)
	LD   L,A
	LD   A,(SLIPX)
	LD   B,6
	CALL GSPUTSPRITE
	RET
	
;==========================================================
; InitValues - Reset all saferam area's except the levelarea
;==========================================================
INITVALUES:
	CALL EMPTYLEVEL
	LD   HL,MAPX
	LD   B,8
	XOR  A
INITLOOP:		
	LD   (HL),A
	INC  HL
	DJNZ INITLOOP
	DEC  A
	LD   (POS),A
	RET

;==========================================================
; FirstAdress - Loads the first leveladress
;==========================================================
LOADSELECTEDADRESS:
	LD   HL,MAPDATA
	LD   A,(SELLEVEL)
	DEC  A
	LD   B,A
	LD   A,(HL)
	SUB  B
	LD   (LAMOUNT),A
	INC  HL
	LD   A,H
	LD   (LADRESS),A
	LD   A,L
	LD   (LADRESS+1),A
	;FIRST LEVEL IS NOW LOADED
	LD   A,(SELLEVEL)
	DEC  A
	RET  Z
	LD   B,A
LOADSELECTEDADRESSLOOP:
	PUSH BC
	LD   B,5
LOADSELECTEDADRESSLOOP2:
	INC  HL
	LD   A,(HL)
	CP   254
	JR   Z,TERMINATORFOUND
	JR   LOADSELECTEDADRESSLOOP2
TERMINATORFOUND:
	DJNZ LOADSELECTEDADRESSLOOP2	
	POP  BC
	DJNZ LOADSELECTEDADRESSLOOP
	INC  HL
	LD   A,H
	LD   (LADRESS),A
	LD   A,L
	LD   (LADRESS+1),A	
	RET
;==========================================================
; CountCoins - Loads the level into the saferam
;==========================================================
COUNTCOINS:
	XOR A
	LD  (COINS),A
	LD  HL,LEVEL
	LD  B,160
COUNTCOINSLOOP:
	LD  A,(HL)
	CP  2
	JR  Z, COUNTCOINSUP
COUNTSCOINSLOOP_CON:	
	INC HL
	DJNZ COUNTCOINSLOOP
	RET
COUNTCOINSUP
	LD  A,(COINS)
	INC A
	LD  (COINS),A
	JR  COUNTSCOINSLOOP_CON
;==========================================================
; Loadlevel - Loads the level into the saferam
;==========================================================
LOADLEVEL:
	CALL EMPTYLEVEL
	LD   A,(LADRESS)
	LD   (LCURRENT),A
	LD   H,A
	LD   A,(LADRESS+1)
	LD   (LCURRENT+1),A
	LD   L,A
	DEC HL
	LD   DE,LEVEL
	LD   B,$01
LOADLEVELLOOP:
	INC  HL
	LD   A,(HL)
	CP   254
	JR   Z,LOADLEVEL_NEXTTILE
	PUSH HL
	LD   L,A
	LD   H,$00
	ADD  HL,DE
	LD   (HL),B
	POP  HL
	JR   LOADLEVELLOOP
LOADLEVEL_NEXTTILE:
	INC  B
	LD   A,B
	CP   6
	JR   Z,QUITLOADLEVEL
	JR   LOADLEVELLOOP
QUITLOADLEVEL:
	INC  HL
	LD   A,H
	LD   (LADRESS),A
	LD   A,L
	LD   (LADRESS+1),A
	RET

;==========================================================
; Emptylevel - Clears the level
;==========================================================
EMPTYLEVEL:
	LD   HL,LEVEL
	LD   B,160
	XOR  A
EMPTYLEVELLOOP:		
	LD   (HL),A
	INC  HL
	DJNZ EMPTYLEVELLOOP
	RET	

;==========================================================
; Resetlevel - Loads the current adress in the next-level adress
;==========================================================
RESETLEVEL:
	LD   A,(LCURRENT)
	LD   (LADRESS),A
	LD   A,(LCURRENT+1)
	LD   (LADRESS+1),A
	
	LD   HL,LAMOUNT
	INC  (HL)
	LD   HL,SELLEVEL
	DEC  (HL)
	
;==========================================================
; Nextlevel - Loads the new leveladress and runs loadlevel
;==========================================================
NEXTLEVEL:
	LD   A,(LAMOUNT)
	DEC  A
	LD   (LAMOUNT),A
	OR   A
	JP   Z,LEVELSELECTION
	LD   A,(LEVELMAX)
	LD   B,A
	LD   A,(SELLEVEL)
	CP   B 
	CALL Z,INCMAX		
	INC  A
	LD   (SELLEVEL),A
	CALL INITVALUES
	CALL LOADLEVEL
	CALL COUNTCOINS
	CALL GSCLEARBUFFER
	LD   HL,LEVEL
	CALL DRAWMAP
	CALL GSCOPYBUFFER
	JP   MAINLOOP
INCMAX:
	LD   HL,LEVELMAX
	INC  (HL)
	RET
;==========================================================
; Drawmap - Plots the map to the screen
;==========================================================
DRAWMAP:
	PUSH HL		
	;FIRST WE HAVE TO DRAW THE WALLS...	
	XOR  A
	LD  (MAPX),A
	LD  (MAPY),A
DRAWMAPLOOP:
  	LD   HL,POS
  	INC  (HL)
	POP  HL
	LD   A,(HL)
	CP   5
	CALL Z,SETPLAYERXY
	INC  HL
	PUSH HL
	ADD  A,A ;X2
	ADD  A,A ;X4
	LD   B,A
	ADD  A,A ;X8
	ADD  A,B ;X12
	LD   E,A
	LD   D,$00
	LD   HL,TILEDATA
	ADD  HL,DE
	PUSH HL
	POP  IX ;---> IX POINTS TO THE PROPER TILE
	LD   A,(MAPY)
	LD   L,A
	LD   A,(MAPX)
	LD   B,6
	CALL GSPUTSPRITE
	LD   A,(MAPX)
	ADD  A,6
	LD   (MAPX),A
	CP   96
	JR   Z,DRAWMAP_NEWLINE
	JR   DRAWMAPLOOP
DRAWMAP_NEWLINE:
	LD   A,0
	LD   (MAPX),A
	LD   A,(MAPY)
	ADD  A,6
	LD   (MAPY),A
	CP   60
	POP  HL
	RET  Z
	PUSH HL
	JR   DRAWMAPLOOP

;==========================================================
; SetplayerXY - Writes the X,Y from the map values to the 
;               X,Y from the char
;==========================================================
setplayerXY:
	LD  A,(mapX)
	LD  (slipX),A
	LD  A,(mapY)
	LD  (slipY),A
	LD  A,(pos)
	LD  (slipPos),A
	XOR A
	LD  (HL),A
	LD  A,5
	RET
;==========================================================
; Delay - Creates a dealy
;==========================================================
DELAY:
	PUSH BC
	LD   B,255
DELAYLOOP:
	PUSH BC
	POP  BC
	DJNZ DELAYLOOP
	POP  BC
	DJNZ DELAY
	RET
;==========================================================
;Input: HL = number to convert, DE = location of ASCII string
;Output: ASCII string at (DE) 
LBLNUM2DEC:
	LD	  BC,-10000
	CALL	LBLNUM1
	LD	  BC,-1000
	CALL	LBLNUM1
	LD	  BC,-100
	CALL	LBLNUM1
	LD	  C,-10
	CALL	LBLNUM1
	LD	  C,B
LBLNUM1:
	LD	  A,'0'-1
LBLNUM2:
	INC	  A
	ADD	  HL,BC
	JR	  C,LBLNUM2
	SBC	  HL,BC
	LD	  (DE),A
	INC	  DE
	RET
	
;==========================================================
; grayscale include file
;==========================================================
; comment these defines in or out to activate/deactivate them

;#DEFINE NODOUBLEBUFFER	;when on,routines write directly to screen (faster and smaller)
;#DEFINE 3LEVELGRAY	;makes it 3-level grayscale (a bit faster)
#DEFINE XORSPRITE	;includes gsPutSprite
#DEFINE LARGESPRITE	;includes gsLargeSprite
;#DEFINE ALIGNEDSPRITE	;includes gsAlignedsprite
;#DEFINE ALIGNEDMASKEDSPRITE

#include "Includes\graylib.inc"
;==========================================================
Text_data:
Temp_Text:
	.db "      ",0
Level_Text:
	.db "Level:",0
Change_Text:
	.db "Arrows: Level",0
Start_Text:
	.db "2nd: Start",0
Quit_Text:
	.db "Mode: Quit ",0
;==========================================================
level:
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
 .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
;==========================================================

#include "Resources\include.inc"

.endmodule